commit f019eae5df7955c544e491517c4e1391a3c3f11e
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-27
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-27

    mingw32: Use LANG_ENGLISH for error message

commit 247084f9c32bcd12b15fe0bb83bb3646b37bae01
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-27
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-27

    Fixed bug that USR_BASENAME is not defined
    
    In some cases, if the dirname is only "/", the basename will not be
    defined (e.g., "/f"). This change fixes this bug.

commit e1f661d5b7d854e42fc32c6c0ec36c7f04836df5
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-26
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-26

    Updated NEWS for 1.16.1 release

commit e9de4db0d57cabb7dee16c821185ff01a9c8986f
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-26
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-26

    Updated bash_completion

commit bd671403bcaeb3dcd718e8a0ddc760170c4e3557
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-26
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-26

    Fix compiler warning

commit c09a5a95f4963cd67c5f3c92250ac3c1876bc430
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-24
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-24

    mingw32: Re-open files with read-only mode enabled on seeding
    
    On Mingw32 build, if aria2 opens file with GENERIC_WRITE access right,
    some programs cannot open the file aria2 is seeding. To avoid this
    situation, re-open files with read-only enabled when seeding is about
    to begin.

commit 43cee0c2641b9867a7e2506264eaedf583727034
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-24
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-24

    Updated Compiling Android  binary section about toolchain path

commit d13aa3a0b3b32c619e17c4c30d767267c3648359
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-24
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-24

    Added missing IndexedList.h to SRCS

commit 616cd9e75f49b7b3a29e7f2337b3f1f92ab4226a
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-22
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-22

    Simplified RequestGroupMan::fillRequestGroupFromReserver

commit b017e80438a785ea228a6e89411e060556dd730a
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-19
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-19

    Changed threshold of using upper unit for abbrevSize

commit 07bb779eb05478864efb8b5f4d264945bb3f30ac
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-19
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-19

    Faster deletion of RequestGroup and DownloadResult lists

commit d2892cf7b467c62b63c12a57c7c0ab424b79f7b1
Author:     ITriskTI <ITriskTI@gmail.com>
AuthorDate: 2012-12-17
Commit:     ITriskTI <ITriskTI@gmail.com>
CommitDate: 2012-12-17

    Update doc/manual-src/ru/aria2c.rst

commit c8565360b0dadcef72df75bd9ba244b36c8bdaec
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-17
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-17

    Removed unused variables

commit 77a4ee4de008ff38d884f283c0b2f6ba4ce75390
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-17
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-17

    Save gid option with --save-session option

commit 983cb3683afd1fa540192059cbe38fb62cc6ffba
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-16
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-16

    Documented --gid option and updated RPC interface section in man page

commit 0a4ce4fdb5fb60eeb2c236e01c7bc54c2627ad83
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-16
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-16

    Use map to make DownloadResult lookup fast

commit 0001f4cfbdc4c9550f133111c84c71f9ad1a68f9
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-16
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-16

    Added --gid option
    
    This option sets GID manually. aria2 identifies each download by the
    ID called GID. The GID must be hex string of 16 characters, thus
    [0-9a-zA-Z] are allowed and leading zeros must not be stripped. The
    GID all 0 is reserved and must not be used. The GID must be unique,
    otherwise error is reported and the download is not added.  This
    option is useful when restoring the sessions saved using
    --save-session option. If this option is not used, new GID is
    generated by aria2.

commit b9da9d4ed3ef9fe7b1488506555e3605aeb500ed
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-16
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-16

    Use 64 bits random bytes as GID
    
    This change replaces the current 64 bit sequential GID with 64 bits
    random bytes GID in an attempt to support persistent GID. Internally,
    the GID is stored as uint64_t. For human representation and RPC
    interface, GID is represented as 16 bytes hex string. For console
    readout, 16 bytes are too long, so it is abbreviated to first 6 bytes.
    When querying GID in RPC calls, user can speicfy the prefix of GID as
    long as the prefix is shared by more than 1 GID entries.

commit 04586f50b17317ef257f6d3f81190021c93ad5ea
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-16
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-16

    Fixed BitfieldMan::getOffsetCompletedLength overflow on 32-bit systems

commit de1ca6d6b80c3784a788671977223a4c1bbf9a25
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-15
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-15

    mingw32: Use HANDLE only for MinGW32 build

commit 8c3e08f15a64bbb4f928152f635034f2c727f0b2
Author:     ITriskTI <ITriskTI@gmail.com>
AuthorDate: 2012-12-12
Commit:     ITriskTI <ITriskTI@gmail.com>
CommitDate: 2012-12-12

    Update doc/manual-src/ru/aria2c.rst

commit 0995d3fa0cb7a80ea3e9513b82f724ef731bc46a
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-13
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-13

    Updated README.rst

commit 2235743de303b407cb8d3f0069260842ed3c41f3
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-12
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-12

    Changed console readout, making it more compact
    
    "SIZE:" is removed because it is obvious. SEEDING, SEED, SPD and UP
    are now replaced with SEED, SD, DL and UL respectively.

commit 4fdd5da27dd167caf14c3591383b59e41cef9089
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-11
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-11

    Compact readout when more than 1 simultaneous downloads are going on
    
    If more than 1 simultaneous downloads are going on, use more compact
    format in readout. Currently, at most 5 download stats are displayed.
    
    util::abbrevSize() is rewritten to support "Gi" unit and provides more
    compact abbreviation.

commit 79fce29bda0dadc5e970693c28ed6cd421ae9e95
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-11
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-11

    Fixed segmentation fault if fp_ is NULL

commit e86fd44dc5a87d64efc18652b2833ae17b72bf10
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-08
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-08

    Console color output
    
    Log level and download result string is now colored.

commit 9a5fff0de095078932e2878338acaa12a5c9daa3
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-08
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-08

    Logger: Simplified console output and change level format in log
    
    The date and time are now removed from console output.  The log level
    is now formatted as "[LEVEL]".

commit 2364f809c3facae25c430cadf2fc1d9e651ad37b
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-08
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-08

    Code cleanup: Merged successive string literals in readout

commit bf56f3c2999bd073c952dfd20aa2c98650f6c95c
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-08
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-08

    Check the output file is terminal or not in ctor

commit 9d7bb9d01af2c0ef1b748ac2e240b20439285fd4
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-08
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-08

    Release statically allocated resources for prefs and options
    
    Not realeasing these resources does not hurt the correctness of the
    program, but memory leak detection tool, such as valgrind, reports it
    as potential memory leak. It is better to distinguish it from the real
    ones.

commit a8641b0998af7b2a5876a77d4f18c9a78230d6b1
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-08
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-08

    Updated .gitignore

commit 3e656fd6d1735cfd603475c427519804623e01ea
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-07
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-07

    Bump up version number to 1.16.1

commit 0c491b86d02aa0a049f9fafc4f29296a728befa6
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-07
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-07

    Documented --disk-cache option in man page

commit 901227db9b9abbe3eb1122b5b7e68d5c40fb6079
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-07
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-07

    Updated usage of --disk-cache

commit 7a0217769840acdde53561330b141607600c286c
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-07
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-07

    Start to find faster host before the number of missing segments becomes 1
    
    The old implementation starts to find faster host when the number of
    missing segment becomes 1. Because of --min-split-size option, before
    the number of missing segment becomes 1, the number of connection
    becomes 1 and it can be slow. In this case, we have to wait until the
    last segment is reached. The new implementation starts to find faster
    host when the remaining length is less than --min-split-size * 2, to
    mitigate the problem stated above.

commit 5683f2fb3ee09af4d81260e457c2dcbaf937d157
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-07
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-07

    Removed unused staticSHA1Digest

commit bec0f6dc11316ce9ba80ee4963d98af54a42dc01
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-06
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-06

    Removed warning when --file-allocation=falloc is used in MinGW32 build
    
    The warning was just a mistake. SetFilePointerEx + SetEndOfFile
    actually allocate disk space.

commit a6b18c868bcf32ddb14ddea79281fa3c12e22803
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-06
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-06

    Log size before flush

commit df5f1fe77fac127c10af35b218ce613cbc33db1e
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-06
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-06

    Fixed bug that size_ is not updated when WrDiskCacheEntry::append is called

commit 838949ab85ad830db10f7c683b6105edc6c6bc28
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-06
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-06

    Append new data to the contagious cache data
    
    If we receive small data (e.g., 1 or 2 bytes), cache entry becomes a
    headache. To mitigate this problem, we allocate cache buffer at least
    4KiB and append the data to the contagious cache data.

commit 2c5e77f4222f2d0e62c70a321b4b770467e3dae3
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-06
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-06

    Flush cached data on checkout/cancel Segment
    
    This change prevents the cached data from overlap because of BT peers.

commit 56c498bcbfa1b7645c75e39142ac9f6c6ca369c6
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-06
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-06

    Clear write cache on Segment::clear and Piece::clearAllBlock

commit 9ed8502e742452568695181014410fe924f45e26
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-05
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-06

    Write data in 4K aligned offset in write with disk cache enabled
    
    This greatly reduces disk activity especially on Win + NTFS.  Not so
    much difference on Linux.

commit 911851debbaa573777d9cd38fa2e714ed70e731e
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-03
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-03

    mingw32: Removed FSCTL_SET_SPARSE set

commit 8f2a4cc7167a8c331f6bc9f7983e867c72177214
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-12-03
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-03

    Removed unused members

commit f314719618d181036ceebcf45338ab76559daf55
Author:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
AuthorDate: 2012-11-27
Commit:     Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
CommitDate: 2012-12-03

    Added --disk-cache option
    
    This option enables disk cache. If SIZE is 0, the disk cache is
    disabled. This feature caches the downloaded data in memory, which
    grows to at most SIZE bytes. The cache storage is created for aria2
    instance and shared by all downloads. The one advantage of the disk
    cache is reduce the disk seek time because the data is written in
    larger unit and it is reordered by the offset of the file. If the
    underlying file is heavily fragmented it is not the case.
